package GomokuSwap;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Marty
 */

public class Exp3 extends NodeOfTree implements Comparable{
    private final int NUMBEROFEXPANDINGCHILDREN = 100000;
    private final int maxofvisit = 50000;
    private final int forcyklus = 5;
    static double epsilon = 0.001;
    static double gama = 0.019;
    private final int MIN = -1;
    private final int MAX = 2;
    private boolean isCut = false;
    
    
    public Exp3(Random random) {
        this.random = random;
    }
    
    @Override
    public boolean isLeaf()
    {
        return children == null;
    }
    
    @Override
    public void expandChildren(double[] desk, int numberofused, int max, int swap, int shift, int i, NodeOfTree current)
    {
        
        if (i > NUMBEROFEXPANDINGCHILDREN) {
            children = null;
            return;
        }
        //children = AllMoves.getInstance().getExpandChildren().getChildren(desk, numberofused, random, swap, current.player, color % 2 + 1, shift, i, current.position);
    }
    
    public NodeOfTree select2(int numberofchild, int sequence)
    {
        if (children.size() == 1) {
            return children.get(0);
        }
        NodeOfTree selected = null;
        double mi = gama / numberofchild;
        double sum = 0;
        double[] probability = new double[numberofchild];
        for (NodeOfTree c : children) {
            if (c == null) continue;
            sum += Math.exp(/*mi */ c.valueofgame/c.visited);
            
        }
        int positioninprobability = 0;
        for (NodeOfTree c : children) {
            if (c == null) {
                continue;
            }
            double a = Math.exp(/*mi **/ c.valueofgame / c.visited);
            
            double exp3 = (/*(1 - gama) **/ a) / sum;
            probability[positioninprobability] = exp3;
            positioninprobability++;
        }
        if (sequence > probability.length) {
            sequence = 3;
        }
        int[] positionofused = new int[sequence];
        double[] nbeststates = new double[sequence];
        boolean[] usedfield = new boolean[probability.length];
        for (int i = 0; i < sequence; i++) {
            int posofmax = 0;
            int j = 0;
            for (; j < probability.length; j++) {
                if (!usedfield[j]) {
                    posofmax = j;
                    usedfield[j] = true;
                    break;
                }
            }
            for (; j < probability.length; j++) {
                if (!usedfield[j]) {
                    if (probability[j] > probability[posofmax]) {
                        usedfield[posofmax] = false;
                        posofmax = j;
                        usedfield[j] = true;
                    }
                }
            }
            positionofused[i] = posofmax;
            nbeststates[i] = probability[posofmax];
        }
        
        double pointeronthefield = random.nextDouble();
        int last = sequence - 1;
        for (int i = 0; i < sequence; i++) {
            nbeststates[i] -= nbeststates[last];
        }
        double mysumoffirstn = 0;
        for (int i = 0; i < sequence - 1; i++) {
            mysumoffirstn += nbeststates[i];
        }
        for (int i = 0; i < sequence - 1; i++) {
            pointeronthefield -= nbeststates[i] / mysumoffirstn ;
            if (pointeronthefield <= 0) {
                return children.get(positionofused[i]);
            }
        }
        return selected;
    }
    
    
    @Override
    public void specialactions(int action) 
    {
        switch (action) {
            case 1 : select2(children.size(), 3);
                break;
        }
    }
    
    @Override
     public NodeOfTree select(double[] movesFromMap)
    {
        if (children.size() == 1) {
            return children.get(0);
        }
        NodeOfTree selected = null;
        double mi = gama / children.size();
        double sum = 0;
        double[] probability = new double[children.size()];
        for (NodeOfTree c : children) {
            if (c == null) continue;
            sum += Math.exp(mi * c.valueofgame/c.visited);
            
        }
        int positioninprobability = 0;
        for (NodeOfTree c : children) {
            if (c == null) {
                continue;
            }
            double a = Math.exp(mi * c.valueofgame / c.visited);
            
            double exp3 = ((1 - gama) * a) / sum + mi;
            probability[positioninprobability] = exp3;
            positioninprobability++;
        }
        double pointer = random.nextDouble();
        for (int i = 0; i < children.size(); i++) {
            pointer -= probability[i];
            if (pointer < 0) {
                selected = children.get(i);
                break;
            }
        }
        /* if (printmetheresult == 0) {
            
            for (int i = 0; i < children.length; i++) {
                System.out.format("P = %f  points: %.2f  visited: %.2f | ", probability[i], children[i].valueofgame, children[i].visited);
                if (i % 9 == 0 && i != 0) {
                    System.out.println();
                }
            }

            System.out.println();
            System.out.println();
            return select2(numberofchild, printmetheresult);
            
        }*/
        return selected;
    }
    
    @Override
    public void selectAction(double[] desk, int numberofsimulation)
    {
        
      /*  int[] newdesk = deepcopy(desk);
        List<NodeOfTree> visitsnodes = new ArrayList<NodeOfTree>(228);
        NodeOfTree current = this;
        swap = current.swap;
        boolean end = false;
        visitsnodes.add(this);
        int shift = 1;
        
        MyKey myKey = new MyKey(movesOfBlack(desk), movesOfWhite(desk));
        myKey.mySortBlack();
        myKey.mySortWhite();
        if (!current.isLeaf()) {
            current = current.select(AIPC.gomokuData.get(myKey));
            if (current.currentNumberOfMoves > 8) {
                end = checkTheField(newdesk, current.position, current.color);
                if (end) {
                    current.rolledup(1);
                    return;
                }
            }
            if (current.position < 225 && current.position >= 0) {
                newdesk[current.position] = current.color;
                if (myKey.black.size() == myKey.white.size()) {
                    myKey.black.add(current.position);
                    myKey.mySortBlack();
                } else {
                    myKey.white.add(current.position);
                    myKey.mySortWhite();
                }
                shift = 1;
            } else {
                shift = 0;
            }
            visitsnodes.add(current);
        }
        while (!current.isLeaf()) {
                current = current.select(AIPC.gomokuData.get(myKey));
            if (current.position < 225 && current.position >= 0) {
                newdesk[current.position] = current.color;
                if (myKey.black.size() == myKey.white.size()) {
                    myKey.black.add(current.position);
                    myKey.mySortBlack();
                } else {
                    myKey.white.add(current.position);
                    myKey.mySortWhite();
                }
                shift = 1;
            } else {
                shift = 0;
            } 
            if (current.currentNumberOfMoves > 8) {
                end = checkTheField( newdesk, current.position, current.color);
                if (end) {
                    current.rolledup(1);
                    int value = current.player;
                    for (NodeOfTree node : visitsnodes) {
                        if (value == node.player) {
                            node.rolledup(1);
                        } else {
                            node.rolledup(-1);
                        }
                    }
                    return;
                }
            }
            visitsnodes.add(current);
        }
        NodeOfTree newNode = null;
        current.expandChildren(newdesk, current.currentNumberOfMoves + shift, 225, current.swap, shift, numberofsimulation, current);
        if (current.isLeaf()) {
            /*
            
                 expandChildren can return null when free memory is too small.
            
            */
            //System.out.println("Nedostatek pameti!");
        /*    newNode = current;
             
        } else {
            newNode = current.select(AIPC.gomokuData.get(myKey));
            visitsnodes.add(newNode);
            
        }
        /*
        
             Need implement to SIMULATION
        
        */
     /*   int value = 0;
        value = simulation(newdesk, newNode, myKey);
        if (value == 0) {
            for (NodeOfTree node : visitsnodes) {
                node.rolledup();
            }
            return;
        }
        for (NodeOfTree node : visitsnodes) {
            if (value == node.player) {
                node.rolledup(1);
            } else {
                node.rolledup(-1);
            }
            
        }*/
    }
    
    public int[] deepcopy(int[] old) 
    {
        int[] newfield = new int[225];
        System.arraycopy(old, 0, newfield, 0, newfield.length);
        return newfield;
    }
    
   
    public int numberofcandidates(double[] simulationdesk, int[] canbecandidats)
    {
        int numberOfChildren = 0;
        for (int i = 0; i < canbecandidats.length; i++) {
            if (canbecandidats[i] == 1) {
                numberOfChildren++;
            }
        }
        return numberOfChildren;
    }
    
   
    
    int givemepositionofcandidate(int[] canbecandidates, int positioninfront) 
    {
        int positionofcandidate = 0;
        for (int i = 0; i < canbecandidates.length; i++) {
            if (canbecandidates[i] == 1) {
                if (positionofcandidate == positioninfront) {
                    return i;
                } 
                positionofcandidate++;
            }
        }
        // I am geting back wrong number just for know if something goes wrong.
        return 226;
    }
    
      ArrayList movesOfWhite(double[] deskOfSimulation)
    {
        ArrayList<Integer> whiteMoves = new ArrayList<Integer>();
        for (int i = 0; i < deskOfSimulation.length; i++) {
            if (deskOfSimulation[i] == 1) {
                whiteMoves.add(i);
            }
        }
        return whiteMoves;
    }
    ArrayList movesOfBlack(double[] deskOfSimulation)
    {
        ArrayList<Integer> blackMoves = new ArrayList<Integer>();
        for (int i = 0; i < deskOfSimulation.length; i++) {
            if (deskOfSimulation[i] == 1) {
                blackMoves.add(i);
            }
        }
        return blackMoves;
    }
    
    
    public int simulation(int[] simulationdesk, NodeOfTree current, MyKey myKey)
    {  
      /*  int winplayer = current.player;
        int colorofmove = 0; 
        int numberofmoves = 0;        
        boolean end = false;
        int positionofthechild = 0; 
        int positionondesk = 0;
        colorofmove = current.color;
        numberofmoves = current.currentNumberOfMoves;
            if (current.getPosition() < 225) {
                if (simulationdesk[current.getPosition()] == 0) {
                    numberofmoves++;
                    simulationdesk[current.getPosition()] = current.color;
                    if (myKey.black.size() == myKey.white.size()) {
                        myKey.black.add(current.position);
                        myKey.mySortBlack();
                    } else {
                        myKey.white.add(current.position);
                        myKey.mySortWhite();
                    }
                }

                end = checkTheField(simulationdesk, positionondesk, colorofmove);
                if (end) {
                    return current.player;
                }
            }
        int[] canbecandidats;
        //MyKey myKey = new MyKey(movesOfBlack(simulationdesk), movesOfWhite(simulationdesk));
        canbecandidats = AllMoves.getInstance().getExpandChildren().findAceptableChildren(simulationdesk, AIPC.gomokuData.get(myKey));
        //<editor-fold defaultstate="collapsed" desc="First part, It doesn´t be controled if there is win1">
        if (numberofmoves < 9) {
            int shift = 0;
            boolean choise = false;
            while (numberofmoves < 9) {
                if (numberofmoves <= 5 && !choise) {
                    if (numberofmoves == 3) {
                        shift = 2;
                    } else {
                        if (numberofmoves == 5) {
                            shift = 1;
                        }
                    }
                }
                
                positionofthechild = random.nextInt(numberofcandidates(simulationdesk, canbecandidats));
                
                if (numberofmoves <= 5 && !choise) {
                    if (numberofmoves == 5 || numberofmoves == 3) {
                        if (positionofthechild == 224 + shift - numberofmoves) {
                           choise = true;
                            shift = 0;
                            continue;
                        }
                        if (positionofthechild == 223 + shift - numberofmoves) {
                            winplayer = winplayer % 2 + 1;
                            choise = true;
                            shift = 0;
                            continue;
                        } 
                        if (numberofmoves == 3 || numberofmoves == 5) {
                             winplayer = winplayer % 2 + 1;
                        }
                    }
                        shift = 0;
                } else {
                    winplayer = winplayer % 2 + 1;
                }
                positionondesk = givemepositionofcandidate(canbecandidats, positionofthechild);
                 if (myKey.black.size() == myKey.white.size()) {
                    myKey.black.add(positionondesk);
                    myKey.mySortBlack();
                } else {
                    myKey.white.add(positionondesk);
                    myKey.mySortWhite();
                }
                colorofmove = colorofmove % 2 + 1;
                simulationdesk[positionondesk] = colorofmove;
                canbecandidats[positionondesk] = 0;
                fillPotencialChildren(canbecandidats, positionondesk, simulationdesk, AIPC.gomokuData.get(myKey));
                numberofmoves += 1;
            }
        }
//</editor-fold>
        return secondhalfofsimulation(simulationdesk, winplayer, myKey.black.size() + myKey.white.size(), colorofmove, canbecandidats, myKey);*/
      return -1;
    }
    
    public int secondhalfofsimulation(int[] simulationdesk, int winplayer, int numberofmoves, int colorofmove, int[] canbecandidats, MyKey myKey)
    {
       /* boolean isend = false;
        boolean end = false;

        int positionofthechild;
        int positionondesk = 0;
        int forcykle;
            for (forcykle = 0; forcykle < forcyklus; forcykle++) {
            positionofthechild = random.nextInt(numberofcandidates(simulationdesk, canbecandidats));
            positionondesk = givemepositionofcandidate(canbecandidats, positionofthechild);
            colorofmove = colorofmove % 2 + 1;
            winplayer = winplayer % 2 + 1;
            end = checkTheField(simulationdesk, positionondesk, colorofmove);
            if (end) {
                isend = true;
                break;
            }
            numberofmoves += 1;
            if (numberofmoves == 225) {
                writeout(simulationdesk, positionondesk, colorofmove);
                return 0;
            }
           if (myKey.black.size() == myKey.white.size()) {
                    myKey.black.add(positionondesk);
                    myKey.mySortBlack();
                } else {
                    myKey.white.add(positionondesk);
                    myKey.mySortWhite();
                }
            simulationdesk[positionondesk] = colorofmove;
            canbecandidats[positionondesk] = 0;
            fillPotencialChildren(canbecandidats, positionondesk, simulationdesk, AIPC.gomokuData.get(myKey));

        }*/
        /*if (forcykle == forcyklus) {
            return 0;
        } */
        return winplayer;
    }
    
    boolean issafe(int position, int minusint, int realpos)
    {
        if (position < 0) return false;
        if (position > 224) return false;
        if (minusint < 0) {
            if (position % 15 > realpos % 15 - minusint) {
                return false;
            } 
        }
        if (minusint > 0) {
            if (position % 15 < realpos % 15 + minusint) {
                return false;
            }
        }
        return true;
    }
    
    boolean canbecontrol(int i, int j) 
    {
        return i == 0 || j == 0;
    }
    
    int fillpotencialchildren(int[] potencialchildren, int position, double[] desk, ArrayList<Integer> myKey)
    {
        
        int numberofchildren = 0;
         if (myKey == null) {
        for (int i = MIN; i < MAX; i++) {
            for (int j = MIN; j< MAX; j++) {
                if (i == 0 && j == 0) continue;
                if (i == j || -i == j || canbecontrol(i, j)) {
                    if (issafe(i * 15 + j + position, j, position)) {
                        if (desk[i * 15 + j + position] == 0) {
                            potencialchildren[i * 15 + j + position] = 1;
                            numberofchildren++;
                        }
                    }
                }
            }
        }
        } else {
            AIPC.giveMeNumberOfFound += 1;
            for (int i = 0; i < myKey.size(); i++) {
                potencialchildren[myKey.get(i)] = 1;
                numberofchildren++;
            }
        }
        return numberofchildren;
    }
    
    
    
    private int movesinsidelefthorizontal(int shift, double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = shift;
           int locmax = 6 - shift; 
            for (int i = 1; i < locmax; i++) {
            shiftondesk--;
            if (shiftondesk < 0) {
                return movesinside;
            }
            if (shiftondesk % 15 == 14) {
                return movesinside;
            }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private int movesinsiderighthorizontal(double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = 0;
            for (int i = 1; i < 6; i++) {
            shiftondesk++;
                if (shiftondesk % 15 == 0) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    
    private int movesinsideup(int shift, double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = shift;
           int locmax = 6 - shift; 
            for (int i = 1; i < locmax; i++) {
            shiftondesk -= 15;
 
                if (shiftondesk < 0) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private int movesinsidedown(double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = 0;
            for (int i = 1; i < 6; i++) {
            shiftondesk += 15;
                if (shiftondesk > 224) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private int movesinsideleftup(int shift, double[] field, int shiftondesk, int colorofplayer)
    {
          int movesinside = shift;
           int locmax = 6 - shift; 
            for (int i = 1; i < locmax; i++) {
            shiftondesk -= 16;
 
                if (shiftondesk < 0) {
                    return movesinside;
                }
                if (shiftondesk % 15 == 14) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private int movesinsiderightdown(double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = 0;
            for (int i = 1; i < 6; i++) {
            shiftondesk += 16;
                if (shiftondesk > 224) {
                    return movesinside;
                }
                if (shiftondesk % 15 == 0) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private int movesinsiderightup(int shift, double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = shift;
           int locmax = 6 - shift; 
            for (int i = 1; i < locmax; i++) {
            shiftondesk -= 14;
 
                if (shiftondesk < 0) {
                    return movesinside;
                }
                if (shiftondesk % 15 == 0) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private int movesinsideleftdown(double[] field, int shiftondesk, int colorofplayer)
    {
           int movesinside = 0;
            for (int i = 1; i < 6; i++) {
                shiftondesk +=  14;
                if (shiftondesk > 224) {
                    return movesinside;
                }
                if (shiftondesk % 15 == 14) {
                    return movesinside;
                }
            if (field[shiftondesk] == colorofplayer) {
                movesinside++;
            } else {
                return movesinside;
            }
        }
        return 0;
    }
    
    private boolean checkTheField( double[] field, int positionoflastmove, int colorofplayer)
    {
        int moveuphorizontal = movesinsidedown(field, positionoflastmove, colorofplayer);
        int movedownhorizontal = movesinsideup(moveuphorizontal, field, positionoflastmove, colorofplayer);
        if (movedownhorizontal == 4) {
            return true;
        }
        
        int moverightvertical = movesinsiderighthorizontal(field, positionoflastmove, colorofplayer);
        int moveleftvertical = movesinsidelefthorizontal(moverightvertical, field, positionoflastmove, colorofplayer);
        if (moveleftvertical == 4) {
            return true;
        }
        
        int moverightdowndiagonal = movesinsiderightdown(field, positionoflastmove, colorofplayer);
        int moveleftupdiagonal = movesinsideleftup(moverightdowndiagonal, field, positionoflastmove, colorofplayer);
        if (moveleftupdiagonal == 4) {
            return true;
        
        }
        int moveleftdowndiagonal = movesinsideleftdown(field, positionoflastmove, colorofplayer);
        int moverightupdiagonal = movesinsiderightup(moveleftdowndiagonal, field, positionoflastmove, colorofplayer);
        
        return moverightupdiagonal == 4;
    }
    
    public void writeout(double[] simulationdesk, int lastmove, int colorofmove)
    {
        
        for (int i = 0; i < 15; i++) {
            for (int j = 0; j < 15; j++) {
                if (i * 15 + j == lastmove) {
                    if (colorofmove == 2) {
                        System.out.format("* ");
                    } else {
                        System.out.format("# ");
                    }
                    continue;
                }
                System.out.format("%d ", simulationdesk[i * 15 + j]);
            }
            System.out.println();
        }
            System.out.println();
            System.out.println();
    }
    
    @Override
    public void rolledup()
    {
         visited++;
    }
    
    @Override
    public void rolledup(int value)
    {
        visited++;
        valueofgame += value;
    }
    
    @Override
    public double getVisited() {
        return visited;
    }

    @Override
    public void setVisited(double visited) {
        this.visited = visited;
    }

    @Override
    public double getValueofgame() {
        return valueofgame;
    }

    @Override
    public void setValueofgame(double valueofgame) {
        this.valueofgame = valueofgame;
    }

    @Override
    public int getPosition() {
        return position;
    }

    @Override
    public void setPosition(int position) {
        this.position = position;
    }
    
    private void positionsdesk(int[] desk)
    {
        for (int i = 0; i < 15; i++) {
            for (int j = 0; j < 15; j++) {
                if (desk[i * 15 + j] == 2) {
                    System.out.format("* ");
                    continue;
                }
                if (desk[i * 15 + j] == 1) {
                    System.out.format("# ");
                    continue;
                }
                if (desk[i * 15 + j] == 0) {
                    System.out.format("  ");
                }
            }
            System.out.println();
        }
    }
    
    private void action()
    {
        double[] game = {
            1, 2, 2, 1, 2, 2, 1, 2, 2, 2, 1, 2, 2, 2, 1, 
2, 1, 1, 2, 2, 2, 1, 2, 1, 2, 1, 2, 1, 1, 2, 
2, 1, 1, 2, 1, 1, 2, 0, 1, 2, 2, 2, 1, 1, 2, 
2, 2, 1, 2, 2, 1, 1, 2, 2, 1, 1, 1, 2, 1, 1, 
1, 2, 1, 2, 1, 2, 2, 1, 1, 2, 2, 1, 2, 1, 2, 
2, 0, 2, 1, 2, 1, 1, 2, 2, 1, 1, 0, 2, 2, 1, 
1, 1, 2, 2, 2, 1, 2, 1, 0, 1, 2, 2, 1, 2, 1, 
1, 2, 1, 2, 1, 1, 2, 1, 1, 1, 1, 2, 2, 2, 2, 
1, 1, 2, 2, 1, 2, 1, 2, 2, 2, 1, 1, 1, 1, 2, 
2, 1, 1, 0, 1, 2, 1, 2, 1, 1, 2, 2, 2, 1, 1, 
1, 1, 2, 1, 2, 1, 1, 1, 2, 1, 2, 1, 1, 2, 1, 
1, 1, 2, 1, 2, 1, 2, 1, 1, 1, 2, 2, 1, 1, 1, 
2, 2, 1, 2, 2, 2, 1, 2, 2, 2, 1, 1, 2, 2, 2, // 180 last move
2, 1, 2, 2, 1, 0, 1, 2, 1, 2, 1, 1, 2, 1, 1, 
0, 1, 2, 0, 1, 2, 1, 1, 2, 2, 1, 2, 2, 0, 2 

        } ;
        CheckTheEndOfGame checkTheEndOfGame = new CheckTheEndOfGame(game, 180, 2, currentNumberOfMoves);
       System.out.println( checkTheField(game, 180, 2) + " "+ checkTheEndOfGame.end);
        
        int[] newfield = new int[225];
        newfield[42] = 2;
       // newfield[126] = 1;
        newfield[57] = 2;
        newfield[82] = 1;
        newfield[62] = 2;
       // newfield[97] = 1;
        newfield[77] = 2;
        //newfield[143] = 1;
        //newfield[109] = 1;
        // newfield[79] = 2;
        //  newfield[111] = 1;
        //  newfield[34] = 2;
        // newfield[49] = 1;
        //  newfield[80] = 2;
        //  newfield[78] = 1;
        //newfield[143] = 1;
          positionsdesk(newfield);
        
        //newfield[]
        int valueofblackwin = 0;
        int valueofwhitewin = 0;
        int drawsvalue = 0;
        int valueofgame = 0;
        for (int i = 0; i < 10; i++) {
            int[] copyfield = deepcopy(newfield);
            color = 2;
            player = 2;
            currentNumberOfMoves = 5;
            int win = simulation(copyfield, new Exp3(random), new MyKey(new ArrayList<Integer>(), new ArrayList<Integer>()));
            switch(win) {
                case 0 : drawsvalue += 1;
                    break;
                case 1 : valueofwhitewin += 1;
                        valueofgame -= 1;
                    break;
                case 2 : valueofblackwin += 1;
                        valueofgame += 1;
                    break;
            }
        }
        System.out.format("White moves win %d simulations.%nBlack moves win %d simulations.%nDraws simulations %d.%n Value of game: %d!%n", 
                valueofwhitewin, valueofblackwin, drawsvalue, valueofgame);
    }
    
    @Override
    public String toString()
    {
        
        return "Color is: " + String.valueOf(color) + " " + "\nposition is: " + String.valueOf(position) + "\nNumber of move: " + String.valueOf(currentNumberOfMoves) + "\nAI is: Exp3\n";
    }
    
    
    public static void main(String[] args) {
        Exp3 nodeOfTree = new Exp3(new Random(255));
        nodeOfTree.action();
    }

    @Override
    public boolean isIsCut() {
        return isCut;
    }

    @Override
    public void setIsCut(boolean isCut) {
        
    }

    @Override
    public NodeOfTree selectafterexpand(double[]  movesFromMap) {
       return null;
    }
    
     @Override
    public int compareTo(Object o) {
        int compareage=((Exp3)o).getPosition();
        /* For Ascending order*/
        return this.getPosition()-compareage;
    }

}
