package NeuralNetwork;


import java.io.IOException;

/**
 * Created by Maaarty on 4.3.2017.
 */
public class GomokuDataSetIteratorSmall extends BaseDatasetIteratorSmall {

    public GomokuDataSetIteratorSmall(int batch, int numExamples) throws IOException {
        this(batch,numExamples,false, 0, 0);
    }

    /**Get the specified number of examples for the MNIST training data set.
     * @param batch the batch size of the examples
     * @param numExamples the overall number of examples
     * @param binarize whether to binarize mnist or not
     * @throws IOException
     */
    public GomokuDataSetIteratorSmall(int batch, int numExamples, boolean binarize, int i, int t) throws IOException {
        this(batch,numExamples,binarize,true,false,0, i, t);
    }

    /** Constructor to get the full MNIST data set (either test or train sets) without binarization (i.e., just normalization
     * into range of 0 to 1), with shuffling based on a random seed.
     * @param batchSize
     * @param train
     * @throws IOException
     */
    public GomokuDataSetIteratorSmall(int batchSize, boolean train, int seed, int i, int t) throws IOException{
        this(batchSize, (train ? GomokuDataFetcherSmall.NUM_EXAMPLES : GomokuDataFetcherSmall.NUM_EXAMPLES_TEST), false, train, true, seed, i, t);
    }

    /**Get the specified number of MNIST examples (test or train set), with optional shuffling and binarization.
     * @param batch Size of each patch
     * @param numExamples total number of examples to load
     * @param binarize whether to binarize the data or not (if false: normalize in range 0 to 1)
     * @param train Train vs. test set
     * @param shuffle whether to shuffle the examples
     * @param rngSeed random number generator seed to use when shuffling examples
     */
    public GomokuDataSetIteratorSmall(int batch, int numExamples, boolean binarize, boolean train, boolean shuffle, long rngSeed, int i, int t) throws IOException {
        super(batch, numExamples,new GomokuDataFetcherSmall(binarize,train,shuffle,rngSeed, i, t));
    }


}