package NeuralNetwork;


import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by Maaarty on 7.3.2017.
 */
public class GomokuLabelFile extends GomokuDbFile {

    /**
     * Creates new MNIST database label file ready for reading.
     *
     * @param name
     *            the system-dependent filename
     * @param mode
     *            the access mode
     * @throws IOException
     * @throws FileNotFoundException
     */
    public GomokuLabelFile(String name, String mode) throws IOException {
        super(name, mode);
    }

    /**
     * Reads the integer at the current position.
     *
     * @return integer representing the label
     * @throws IOException
     */
    public int readLabel() throws IOException {
        return readUnsignedByte();
    }

    /** Read the specified number of labels from the current position*/
    public ArrayList<float[]> readLabels(int num) throws IOException {
        ArrayList<float[]> out = new ArrayList<float[]>(num);
        for( int i=0; i<num; i++){
            /*if ((i % 10000) == 0) {
                System.out.println("We have loaded " + i + " labels!");
            }*/
            float[] line = new float[225];
            String[] newLine = readLine().split(" ");
            for (int j = 0; j < newLine.length; j+=2) {
                line[(Integer.valueOf(newLine[j]))] = (Float.valueOf(newLine[j + 1]));
            }
            out.add(line);
        }
        return out;
    }

    @Override
    protected int getMagicNumber() {
        return 2049;
    }
}
