package NeuralNetwork;

import org.deeplearning4j.api.storage.StatsStorage;
import org.deeplearning4j.nn.conf.LearningRatePolicy;
import org.deeplearning4j.nn.conf.layers.*;
//import org.deeplearning4j.parallelism.ParallelWrapper;
import org.deeplearning4j.optimize.listeners.PerformanceListener;
import org.deeplearning4j.ui.api.UIServer;
import org.deeplearning4j.ui.stats.StatsListener;
import org.deeplearning4j.ui.storage.InMemoryStatsStorage;
import org.deeplearning4j.util.ModelSerializer;
import org.nd4j.linalg.api.buffer.DataBuffer;
import org.nd4j.linalg.api.buffer.util.DataTypeUtil;
import org.nd4j.linalg.dataset.api.iterator.DataSetIterator;
import org.nd4j.linalg.factory.Nd4j;
import org.slf4j.ILoggerFactory;
import org.slf4j.Logger;
import org.deeplearning4j.nn.api.OptimizationAlgorithm;
import org.deeplearning4j.nn.conf.MultiLayerConfiguration;
import org.deeplearning4j.nn.conf.NeuralNetConfiguration;
import org.deeplearning4j.nn.conf.Updater;
import org.deeplearning4j.nn.conf.inputs.InputType;
import org.deeplearning4j.nn.multilayer.MultiLayerNetwork;
import org.deeplearning4j.nn.weights.WeightInit;
//import org.deeplearning4j.optimize.listeners.ScoreIterationListener;
import org.nd4j.linalg.activations.Activation;
import org.nd4j.linalg.api.ndarray.INDArray;
import org.nd4j.linalg.dataset.DataSet;
import org.nd4j.linalg.lossfunctions.LossFunctions;
//import org.nd4j.jita.conf.CudaEnvironment;

import org.slf4j.LoggerFactory;

import java.io.File;
import java.io.FileWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;
import java.util.Scanner;

import static org.slf4j.LoggerFactory.getILoggerFactory;

/**
 * Created by Maaarty on 3.3.2017.
 */
public class NeuralNetwork {
    private static final Logger log = getLogger(NeuralNetwork.class);

    public static Logger getLogger(String name) {
        ILoggerFactory iLoggerFactory = getILoggerFactory();
        return iLoggerFactory.getLogger(name);
    }

    public static Logger getLogger(Class<?> clazz) {
        Logger logger = getLogger(clazz.getName());
       /* if(DETECT_LOGGER_NAME_MISMATCH) {
            Class autoComputedCallingClass = Util.getCallingClass();
            if(nonMatchingClasses(clazz, autoComputedCallingClass)) {
                Util.report(String.format("Detected logger name mismatch. Given name: \"%s\"; computed name: \"%s\".", new Object[]{logger.getName(), autoComputedCallingClass.getName()}));
                Util.report("See http://www.slf4j.org/codes.html#loggerNameMismatch for an explanation");
            }
        }
*/
        return logger;
    }

    int s;
    public double localValue = 0;
    public int sizeOfBatch;
    public static int counterOfNotTopOne;
    public static int counterOfNotTopOneInTestData;
    MultiLayerNetwork model;

    public MultiLayerConfiguration giveMeConfiguration(double mainDropOut, double dropOut, int nFilters, double learningRate,
                                                        double biasLearningRate, double lrPolicyDecayRate)
    {

        int nChannels = 1; // Number of input channels
        int outputNum = 225; // The number of possible outcomes
        // int batchSize = 256; // Test batch size
        //int nEpochs = 50; // Number of training epochs
        int iterations = 1; // Number of training iterations
        // int s = 5;
        //  int seed = 125 + s; //

        MultiLayerConfiguration conf = new NeuralNetConfiguration.Builder()
                .seed(12345)
                .iterations(iterations) // Training iterations as above
                .miniBatch(true)
                .regularization(true).dropOut(mainDropOut)//l2(0.0005)//l2(0.0005)//

                /*
                    Uncomment the following for learning decay and bias
                 */
                // TODO menit hodnoty
                .learningRate(learningRate).biasLearningRate(biasLearningRate)
                // TODO pouzit, ale ne inverse
                .learningRateDecayPolicy(LearningRatePolicy.Poly).lrPolicyDecayRate(lrPolicyDecayRate).lrPolicyPower(0.75)
                .weightInit(WeightInit.XAVIER)
                .optimizationAlgo(OptimizationAlgorithm.STOCHASTIC_GRADIENT_DESCENT)
                .updater(Updater.NESTEROVS).momentum(0.9)
                .list()
                //  TODO experimentovat
                // TODO Prvni convolution by melo byt 5 5
                // TODO Vice layers vyhodnejsi
                //.layer(0, new BatchNormalization())
                .layer(0, new ConvolutionLayer.Builder(5, 5)
                        //nIn and nOut specify depth. nIn here is the nChannels and nOut is the number of filters to be applied
                        .nIn(nChannels)
                        .stride(1, 1)
                        //.padding(4, 4)
                        .nOut(nFilters)
                        // .dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())

            /*    .layer(2, new SubsamplingLayer.Builder(SubsamplingLayer.PoolingType.MAX)
                        .kernelSize(2, 2)
                        .stride(1, 1)
                        .build())*/
             /*  .layer(1, new ConvolutionLayer.Builder(5, 5)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                       //.padding(4, 4)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
               /* .layer(4, new SubsamplingLayer.Builder(SubsamplingLayer.PoolingType.MAX)
                        .kernelSize(3, 3)
                        .stride(1, 1)
                       .build())*/
              /*  .layer(2, new ConvolutionLayer.Builder(5, 5)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(4, 4)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(3, new ConvolutionLayer.Builder(5, 5)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(4, 4)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                /*.layer(4, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(5, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(6, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(7, new ConvolutionLayer.Builder(5, 5)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(8, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(9, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(10, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(11, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
                .layer(12, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(2, 2)
                        .nOut(nFilters)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
               /* .layer(12, new ConvolutionLayer.Builder(1, 1)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .padding(1, 1)
                        .nOut(1)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
              /*  .layer(6, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .nOut(nFilters / 4)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
               /* .layer(5, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .nOut(nFilters * 2)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
             /*   .layer(6, new ConvolutionLayer.Builder(3, 3)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .nOut(nFilters * 4)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())*/
               /* .layer(2, new ConvolutionLayer.Builder(5, 5)
                        //Note that nIn need not be specified in later layers
                        .stride(1, 1)
                        .nOut(1)
                        //.dropOut(0.9)
                        .activation(Activation.RELU)
                        .build())
/**/
                // TODO proc negativeloglikelihood
                .layer(1, new OutputLayer.Builder(LossFunctions.LossFunction.MCXENT)
                        .nOut(outputNum)
                        .dropOut(dropOut)
                        .activation(Activation.SOFTMAX)
                        .build())
                .setInputType(InputType.convolutionalFlat(15, 15, 1)) //See note below
                .backprop(true).pretrain(false).build();
        return conf;
    }

    public void prepareNeuralNetwork(int batchSize, int nEpochs, int seed, int seed2, double mainDropOut, double dropOut, int nFilters, double learningRate,
                                     double biasLearningRate, double lrPolicyDecayRate, int s, int numberOfFolder, int numberOfFiles)
    {

        MultiLayerConfiguration conf = giveMeConfiguration(mainDropOut, dropOut, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
        model = new MultiLayerNetwork(conf);
        model.init();
        saveTheModel(model, s, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
    }

    private void myNeuralNetwork(int batchSize, int nEpochs, int seed, int seed2, double mainDropOut, double dropOut, int nFilters, double learningRate,
                                 double biasLearningRate, double lrPolicyDecayRate, int s, int numberOfFolder, int numberOfFiles, int myMax) throws Exception {
      /*  // PLEASE NOTE: For CUDA FP16 precision support is available
        DataTypeUtil.setDTypeForContext(DataBuffer.Type.HALF);

        // temp workaround for backend initialization
        Nd4j.create(1);

        CudaEnvironment.getInstance().getConfiguration()
                // key option enabled
                .allowMultiGPU(true)

                // we're allowing larger memory caches
                .setMaximumDeviceCache(2L * 1024L * 1024L * 1024L)

                // cross-device access is used for faster model averaging over pcie
                .allowCrossDeviceAccess(true);
*/
      //Initialize the user interface backend
    /*UIServer uiServer = UIServer.getInstance();

        //Configure where the network information (gradients, score vs. time etc) is to be stored. Here: store in memory.
        StatsStorage statsStorage = new InMemoryStatsStorage();         //Alternative: new FileStatsStorage(File), for saving and loading later

        //Attach the StatsStorage instance to the UI: this allows the contents of the StatsStorage to be visualized
        uiServer.attach(statsStorage);
*/
        //PerformanceListener perfListener = new PerformanceListener(5, true);
        counterOfNotTopOne = 0;
        counterOfNotTopOneInTestData = 0;
      this.s = s;
      sizeOfBatch = batchSize;


        /*
            Create an iterator using the batch size for one iteration
         */
        log.info("Load data....");
        // TODO Mensi dafky dat(batchs) lepsi
        //System.out.println("Load training data....");
        /* DataSetIterator mnistTrain = new GomokuDataSetIterator(batchSize,true,12345);
        System.out.println("Load testing data....");
        DataSetIterator gomokuTest = new GomokuDataSetIterator(batchSize,false,12345);

        /*
            Construct the neural network
         */
        log.info("Build model....");
       // System.out.println("Build model....");

        /*
        Regarding the .setInputType(InputType.convolutionalFlat(28,28,1)) line: This does a few things.
        (a) It adds preprocessors, which handle things like the transition between the convolutional/subsampling layers
            and the dense layer
        (b) Does some additional configuration validation
        (c) Where necessary, sets the nIn (number of input neurons, or input depth in the case of CNNs) values for each
            layer based on the size of the previous layer (but it won't override values manually set by the user)

        InputTypes can be used with other layer types too (RNNs, MLPs etc) not just CNNs.
        For normal images (when using ImageRecordReader) use InputType.convolutional(height,width,depth).
        MNIST record reader is a special case, that outputs 28x28 pixel grayscale (nChannels=1) images, in a "flattened"
        row vector format (i.e., 1x784 vectors), hence the "convolutionalFlat" input type used here.
        */
        int outputNum = 225; // The number of possible outcomes

        if (s == 0) {
            MultiLayerConfiguration conf = giveMeConfiguration(mainDropOut, dropOut, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
             model = new MultiLayerNetwork(conf);
        } else {
             model = loadTheModel(s, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
        }
        model.init();

        //Then add the StatsListener to collect this information from the network, as it trains
     //   model.setListeners(new StatsListener(statsStorage));
      /*  // ParallelWrapper will take care of load balancing between GPUs.
        ParallelWrapper wrapper = new ParallelWrapper.Builder(model)
                // DataSets prefetching options. Set this value with respect to number of actual devices
                .prefetchBuffer(24)

                // set number of workers equal or higher then number of available devices. x1-x2 are good values to start with
                .workers(4)

                // rare averaging improves performance, but might reduce model accuracy
                .averagingFrequency(3)

                // if set to TRUE, on every averaging model score will be reported
                .reportScoreAfterAveraging(true)

                // optinal parameter, set to false ONLY if your system has support P2P memory access across PCIe (hint: AWS do not support P2P)
                .useLegacyAveraging(true)

                .build();
*/
        System.out.println("Load testing data....");
        Evaluation eval = new Evaluation(outputNum);
        DataSetIterator gomokuTest = new GomokuDataSetIterator(batchSize, false, 12345, -1, -1);
        System.out.println("Train model....");
        //log.info("Train model....");
        Random random = new Random(seed + 1);
       // model.setListeners(new PerformanceListener(1, true));
        model.setListeners(new ScoreIterationListener(1, this,  nFilters, learningRate, biasLearningRate, lrPolicyDecayRate,  eval, gomokuTest));

        long timeX = System.currentTimeMillis();

        // optionally you might want to use MultipleEpochsIterator instead of manually iterating/resetting over your iterator
        //MultipleEpochsIterator mnistMultiEpochIterator = new MultipleEpochsIterator(nEpochs, mnistTrain);


        //int numberOfFiles = 149;
       // int numberOfFiles = 4649;
        boolean[] isitallowed = new boolean[numberOfFiles];
        for (int i = 0; i < isitallowed.length; i++) {
            isitallowed[i] = true;
        }
        DataSetIterator gomokuTrain = null;
        int locMax = 0;
        int newOne = 0;
        int weHaveBlocked = 0;
        for (int i = 0; i < nEpochs; i++) {
            if (weHaveBlocked > numberOfFiles - 1) {
                    break;
                }

            //for (int j = 0; j < 10; j++) {
            //System.out.println("Load training data....");
            //mnistTrain.next() = new GomokuDataSetIterator(batchSize,true,12345);
            //BatchNormalization batchNormalization = new BatchNormalization();
            long time3 = System.currentTimeMillis();
            if (localValue < 12.5 || locMax == 1) {
                locMax = 0;
                boolean isItAllowedLoc = false;
                while(!isItAllowedLoc) {
                    newOne = random.nextInt(numberOfFiles);
                    if (isitallowed[newOne]) {
                        isItAllowedLoc = true;
                    }
                }
                System.out.println("Load training data.... " + newOne);
                gomokuTrain = new GomokuDataSetIterator(batchSize, true, 12345, newOne, numberOfFolder);
                System.out.println("Data have been loaded.... ");
            } else {
                locMax += 1;
                if (locMax == 1) {
                    isitallowed[newOne] = false;
                    System.out.println("We have blocked: " + newOne);
                    weHaveBlocked += 1;
                }
                System.out.println("We will fit again.... ");
            }
            long time4 = System.currentTimeMillis();

            //DataSetIterator gomokuTrain = new GomokuDataSetIterator(batchSize,true,12345, 1029);
            // for (int j = 0; j < 3; j++) {
            long time1 = System.currentTimeMillis();
            // on GPU
         //   wrapper.fit(gomokuTrain);
            // on CPU
            for (int j = 0; j < myMax; j++) {


                model.fit(gomokuTrain);
            }
           /* for (int j = 0; j < 3; j++) {
                if (localValue > 9) {
                    model.fit(gomokuTrain);
                    System.out.println("We have fited again.... ");
                }
            }*/

            long time2 = System.currentTimeMillis();
            //}
            //model.fit(gomokuTrain);

            // }

            //  log.info("*** Completed epoch {} ***", i);
            log.info("*** Completed epoch {}, time: {}, time of loading data: {} ***", i, (time2 - time1), (time4 - time3));
            //System.out.println("*** Completed epoch {} *** " + i);
            if ((i % 20) == 0) {
                System.out.println("Evaluate model....");
                //log.info("Evaluate model....");
                Evaluation forTrainingSet = new Evaluation(outputNum);
                eval = new Evaluation(outputNum);
                while (gomokuTest.hasNext()) {
                    DataSet ds = gomokuTest.next();
                    INDArray output = model.output(ds.getFeatureMatrix(), false);
                    eval.eval(ds.getLabels(), output, false);

                }
                gomokuTrain.reset();
                while (gomokuTrain.hasNext()) {
                    DataSet ds = gomokuTrain.next();
                    INDArray output = model.output(ds.getFeatureMatrix(), true);
                    forTrainingSet.eval(ds.getLabels(), output, true);

                }
                //log.info(eval.stats());
                System.out.println(ANSI_BLUE_BACKGROUND + ANSI_WHITE + eval.stats(1) + ANSI_RESET);
                System.out.println(ANSI_GREEN_BACKGROUND + ANSI_BLUE + forTrainingSet.stats(2) + ANSI_RESET);
                System.out.println("\n Counter for more probabilities for layer in train data : " + NeuralNetwork.counterOfNotTopOne);
                System.out.println("\n Counter for more probabilities for layer in test data : " + NeuralNetwork.counterOfNotTopOneInTestData);

                saveTestingDataToFile(forTrainingSet.stats(), eval.stats(), nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
                gomokuTest.reset();
                saveTheModel(model, s, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
              //  ourTestOfNeuralNetwork(batchSize, nEpochs, seed, seed2, mainDropOut, dropOut, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate, s);
            }
        }
        long timeY = System.currentTimeMillis();
        log.info("*** Training complete, time: {} ***", (timeY - timeX));

        saveTheModel(model, s, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
        System.out.println("****************Learning neural network for GOMOKU finished********************");
        //log.info("****************Example finished********************");
    }

    private boolean saveTheModel(MultiLayerNetwork net, int s, int nFilters, double learningRate, double biasLearningRate, double lrPolicyDecayRate)
    {
        try {
        //Save the model
        File locationToSave = new File("MyMultiLayerNetwork" + learningRate + biasLearningRate + lrPolicyDecayRate + nFilters + ".zip");      //Where to save the network. Note: the file is in .zip format - can be opened externally
        boolean saveUpdater = true;                                             //Updater: i.e., the state for Momentum, RMSProp, Adagrad etc. Save this if you want to train your network more in the future
        ModelSerializer.writeModel(net, locationToSave, saveUpdater);
            System.out.println("We have saved the model.");
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            System.out.println("It have failed when saving the model.");
            System.out.println("It is here 96");

        }
        return true;
    }

    private MultiLayerNetwork loadTheModel(int s, int nFilters, double learningRate, double biasLearningRate, double lrPolicyDecayRate)
    {
        MultiLayerNetwork restored = null;
        try {
           // File locationToSave = new File("MyMultiLayerNetwork" + learningRate + biasLearningRate + lrPolicyDecayRate + nFilters + ".zip");

             // File locationToSave = new File("MyMultiLayerNetworkTopInSeries"  + learningRate + biasLearningRate + lrPolicyDecayRate + nFilters +   ".zip");
             // File locationToSave = new File("MyMultiLayerNetwork0.0050.0012.14.zip");
           // File locationToSave = new File("MyMultiLayerNetwork" + s +  ".zip");
            //File locationToSave = new File("MyMultiLayerNetworkTopInSeries0.011.0E-40.94third.zip");
            //File locationToSave = new File("MyMultiLayerNetworkTopInSeries0.011.0E-40.94FIRST.zip");
            File locationToSave = new File("MyMultiLayerNetworkTopInSeries0.011.0E-40.94SECOND.zip");
            Nd4j.getRandom().setSeed(12345);
            restored = ModelSerializer.restoreMultiLayerNetwork(locationToSave);
            System.out.println("We have loaded the model.");
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            System.out.println("It have failed when loading the model.");
            System.out.println("It is here 96");

        }
        return restored;
    }

    public void saveTestingDataToFile(String trainingStats, String testingStats,  int nFilters, double learningRate, double biasLearningRate, double lrPolicyDecayRate) {
        try {
            Scanner sc = new Scanner(System.in);

            FileWriter fw = null;
            File openingFile = new File("testingStats" + learningRate + biasLearningRate + lrPolicyDecayRate + nFilters + ".txt");
            fw = new FileWriter(openingFile, true);
            FileWriter fw2 = null;
            File openingFile2 = new File("trainingStats" + learningRate + biasLearningRate + lrPolicyDecayRate + nFilters + ".txt");
            fw2 = new FileWriter(openingFile2, true);


                fw2.write(trainingStats);
                fw2.write("\n");

                fw.write(testingStats);
                fw.write("\n");


            fw2.close();
            fw.close();
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            System.out.println("Je to tu 96");

        }
    }

    public void ourTestOfNeuralNetwork(int batchSize, int nEpochs, int seed, int seed2, double mainDropOut, double dropOut, int nFilters, double learningRate,
                                       double biasLearningRate, double lrPolicyDecayRate, int s) throws Exception
    {
        int nChannels = 1; // Number of input channels
        int outputNum = 225; // The number of possible outcomes
         batchSize = 1; // Test batch size
        //int nEpochs = 500; // Number of training epochs
        int iterations = 1; // Number of training iterations
        s = 0;
        //int seed = 1250 + s; //
        MultiLayerNetwork model = loadTheModel(s, nFilters, learningRate, biasLearningRate, lrPolicyDecayRate);
        model.init();

        DataSetIterator gomokuTest = new GomokuDataSetIterator(batchSize, false, 12345, -2, -1);

        Evaluation eval = new Evaluation(outputNum);
        while (gomokuTest.hasNext()) {
            DataSet ds = gomokuTest.next();
            //INDArray output = model.labelProbabilities(ds.getFeatures());
            long time1 = System.nanoTime();
            INDArray output = model.output(ds.getFeatureMatrix(), false);
            long time2 = System.nanoTime();
            System.out.println("Time of geting output from Neural Network: " + ((time2 - time1)));
            double [] outputMatrix = output.data().asDouble();
            eval.eval(ds.getLabels(), output, false);
            System.out.println(stats(false, outputMatrix, ds.getFeatures().data().asInt(), ds.getLabels().data().asInt()));
            //  System.out.println();

        }
        System.out.println(eval.stats());
    }

    public static final String ANSI_RESET = "\u001B[0m";
    public static final String ANSI_BLACK = "\u001B[30m";
    public static final String ANSI_RED = "\u001B[31m";
    public static final String ANSI_GREEN = "\u001B[32m";
    public static final String ANSI_YELLOW = "\u001B[33m";
    public static final String ANSI_BLUE = "\u001B[34m";
    public static final String ANSI_PURPLE = "\u001B[35m";
    public static final String ANSI_CYAN = "\u001B[36m";
    public static final String ANSI_WHITE = "\u001B[37m";

    public static final String ANSI_BLACK_BACKGROUND = "\u001B[40m";
    public static final String ANSI_RED_BACKGROUND = "\u001B[41m";
    public static final String ANSI_GREEN_BACKGROUND = "\u001B[42m";
    public static final String ANSI_YELLOW_BACKGROUND = "\u001B[43m";
    public static final String ANSI_BLUE_BACKGROUND = "\u001B[44m";
    public static final String ANSI_PURPLE_BACKGROUND = "\u001B[45m";
    public static final String ANSI_CYAN_BACKGROUND = "\u001B[46m";
    public static final String ANSI_WHITE_BACKGROUND = "\u001B[47m";

    public String stats(boolean suppressWarnings, double[] outputMatrix,
                        int[] inputGame, int[] inputLabel) {
        String actual, expected;
        StringBuilder builder = new StringBuilder().append("\n");
        StringBuilder warnings = new StringBuilder();


        builder.append("\n");
        //builder.append(warnings);
        System.out.println("It got here.");
        int posOfLocMax = 0;
        double localMax = 0;
        for (int i = 0; i < outputMatrix.length; i++) {
            if (outputMatrix[i] > localMax) {
                localMax = outputMatrix[i];
                posOfLocMax = i;
            }
        }
        DecimalFormat df = new DecimalFormat("0.0000");
        builder.append("\n==========================Values========================================\n|| ");
        for (int i = 0; i < outputMatrix.length; i++) {
            if (i % 15 == 0 && i != 0) {
                builder.append(" ||\n|| ");
            }
            if (outputMatrix[i] < 0.0025) {
                outputMatrix[i] = 0.0000;
            }
            //String s = (char)27 + "[36mbla-bla-bla"; = cyan color
            String k;
            if (i == posOfLocMax) {
                if (inputLabel[i] != 0) {
                    k = ANSI_RED_BACKGROUND + ANSI_WHITE + format(df, outputMatrix[i]) + ANSI_RESET;
                    builder.append(k).append(" ");
                } else {
                    switch (inputGame[i]) {
                        case 0:
                            k = ANSI_GREEN_BACKGROUND + ANSI_WHITE + format(df, outputMatrix[i]) + ANSI_RESET;
                            builder.append(k).append(" ");
                            break;
                        case 1:
                            k = ANSI_GREEN_BACKGROUND + ANSI_BLUE + format(df, outputMatrix[i]) + ANSI_RESET;
                            builder.append(k).append(" ");
                            break;
                        case 2:
                            k = ANSI_GREEN_BACKGROUND + ANSI_BLACK + format(df, outputMatrix[i]) + ANSI_RESET;
                            builder.append(k).append(" ");
                            break;
                        default:
                            k = ANSI_GREEN_BACKGROUND + ANSI_WHITE + format(df, outputMatrix[i]) + ANSI_RESET;
                            builder.append(k).append(" ");
                            break;
                    }
                }
            } else {
                switch (inputGame[i]) {
                    case 0:
                        k = ANSI_WHITE + format(df, outputMatrix[i]) + ANSI_RESET;
                        builder.append(k).append(" ");
                        break;
                    case 1:
                        k = ANSI_BLUE + format(df, outputMatrix[i]) + ANSI_RESET;
                        builder.append(k).append(" ");
                        break;
                    case 2:
                        k = ANSI_BLACK + format(df, outputMatrix[i]) + ANSI_RESET;
                        builder.append(k).append(" ");
                        break;
                    default:
                        k = ANSI_WHITE + format(df, outputMatrix[i]) + ANSI_RESET;
                        builder.append(k).append(" ");
                        break;
                }
            }

        }

        builder.append("\n========================================================================\n\n");
        return builder.toString();
    }

    private static String format(DecimalFormat f, double num){
        if(Double.isNaN(num) || Double.isInfinite(num)) return String.valueOf(num);
        return f.format(num);
    }

    public static void main(String[] args) throws Exception {
        // 256 1000000 1700 1700 0.5 0.8 32 0.0001 0.0001 0.00001 1699
       // 256 1000000 1700 1700 0.5 0.8 8 0.0001 0.0001 0.00001 0
        // last run 256 1000 2400 2400 0.5 0.9 8 0.01 0.01 0.3 2300
        // 512 401 2465 2465 0.7 0.7 8 0.01 0.01 0.05 2465
        // 256 401 2465 2465 0.3 0.5 8 0.01 0.01 1.5 0 5 4605
        // 256 1000000 1770 1770 0.3 0.9 8 0.1 0.01 1.5 0 5 4600
        // want to try:
        // 500 10000 12345 12345 0.5 0.1 8 0.01 0.001 1.7 0 7 2498
        // 1000 30000 12345 12345 0.5 0.1 4 0.00000000000000000001 0.000000000000000000000000000000001 100.9 0 7 2498

        NeuralNetwork neuralNetwork = new NeuralNetwork();

  /*  neuralNetwork.prepareNeuralNetwork(Integer.valueOf(args[0]), Integer.valueOf(args[1]), Integer.valueOf(args[2]), Integer.valueOf(args[3]), Double.valueOf(args[4]),
                Double.valueOf(args[5]), Integer.valueOf(args[6]), Double.valueOf(args[7]), Double.valueOf(args[8]), Double.valueOf(args[9]), Integer.valueOf(args[10]),
                Integer.valueOf(args[11]), Integer.valueOf(args[12]));
/**/
     /*          neuralNetwork.myNeuralNetwork(Integer.valueOf(args[0]), Integer.valueOf(args[1]), Integer.valueOf(args[2]), Integer.valueOf(args[3]), Double.valueOf(args[4]),
               Double.valueOf(args[5]), Integer.valueOf(args[6]), Double.valueOf(args[7]), Double.valueOf(args[8]), Double.valueOf(args[9]), Integer.valueOf(args[10]),
        Integer.valueOf(args[11]), Integer.valueOf(args[12]), Integer.valueOf(args[13]));
        /**/

    neuralNetwork.ourTestOfNeuralNetwork(Integer.valueOf(args[0]), Integer.valueOf(args[1]), Integer.valueOf(args[2]), Integer.valueOf(args[3]), Double.valueOf(args[4]),
                            Double.valueOf(args[5]), Integer.valueOf(args[6]), Double.valueOf(args[7]), Double.valueOf(args[8]), Double.valueOf(args[9]), Integer.valueOf(args[10]));
        /**/
    }



}
